# Copyright (C) @BABOLO  2003 Jan 15
# All rights reserved.
#
# Redistribution and use in source and binary forms, with or without
# modification, are permitted provided that the following conditions
# are met:
# 1. Redistributions of source code must retain the above copyright
#    notice, this list of conditions and the following disclaimer.
# 2. Redistributions in binary form must reproduce the above copyright
#    notice, this list of conditions and the following disclaimer in the
#    documentation and/or other materials provided with the distribution.
#
# THIS SOFTWARE IS PROVIDED BY THE AUTHOR AND CONTRIBUTORS ``AS IS'' AND
# ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
# IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
# ARE DISCLAIMED.  IN NO EVENT SHALL THE AUTHOR OR CONTRIBUTORS BE LIABLE
# FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
# DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
# OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
# HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
# LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
# OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
# SUCH DAMAGE.
#
# $Id: common.make,v 1.6 2003/05/09 22:24:46 babolo Exp $

#######################################################################################################
subdir:
.for I in ${SUBDIR}
	@(cd ${I};\
          ${MAKE} ${MAKEFLAGS} PKG="${PKG}" VMAJOR="${VMAJOR}" VERS="${VERS}" DATE="${DATE}"\
                  CFLAGSPLUS="${CFLAGSPLUS}" PREFIX="${PREFIX}" CONFDIR="${CONFDIR}"\
                  LIBEDIR=${LIBEDIR} ROOTDATA="${ROOTDATA}"\
                  all\
        )
.endfor

#######################################################################################################

.for I in ${MGEN}
 MISC	+= ${I}.m4
${I}: Makefile ${BUILDINCLUDEDIR}/def.m4 def.m4 ${I}.m4
	${M4} -DBUILDINCLUDEDIR=${BUILDINCLUDEDIR} -DLIBINCLUDEDIR=${LIBINCLUDEDIR}\
              -DLIBEDIR=${LIBEDIR} -DBINOVER=${BINOVER} -DBINDIR=${BINDIR} -DDATADIR=${DATADIR}\
              -DVMAJOR=${VMAJOR} -DCAT=${CAT} -DSED=${SED} -DGREP=${GREP} -DAWK=${AWK}\
             ${BUILDINCLUDEDIR}/def.m4 def.m4 ${I}.m4 > ${I}
.endfor

.for I in ${MANS1} ${MANS8}
${I}.gz: Makefile ${I}
	${GZIP} -cn ${I} > ${I}.gz
.endfor

.for I in ${PGMOD}
 MISC	+= ${I}.c
 DATA	+= ${I}.so.${VMAJOR}
${I}.so.${VMAJOR}: Makefile ${I}.c
	${CC} -fpic -shared -o ${I}.so.${VMAJOR} ${I}.c
.endfor

.for I in ${PROG}
${I}: ${OBJS} ${I}.o
	${CC} ${LDFLAGS} ${OBJS} ${I}.o -o ${I}
.endfor

#######################################################################################################
doclean:
	${RM} -f *.o *.so *.so.${VMAJOR} *.core .depend *.bak ${PROG} *.gz index.dir *.shtml ${CLEAN}
.if defined(TITLE)
	${RM} -f index.4tml
.endif
.for I in ${SUBDIR}
	@(cd ${I}; ${MAKE} ${MAKEFLAGS} PKG="${PKG}" RM="${RM}" MAKE="${MAKE}" VMAJOR="${VMAJOR}" clean)
.endfor

#######################################################################################################
doinstall:
.if defined(CONF)
	${MKDIR} -p ${CONFDIR}
. for I in ${CONF}
	${RM} -f ${CONFDIR}/${I}.orig
	${SED} ${SCRIPTFILTER} ${I} > ${CONFDIR}/${I}.orig
	${CHOWN} ${CHOWNER} ${CONFDIR}/${I}.orig
	${CHMOD} ${DATAMODE} ${CONFDIR}/${I}.orig
	@if [ ! -e ${CONFDIR}/${I} ]; then\
            ${CP} -p ${CONFDIR}/${I}.orig ${CONFDIR}/${I};\
        elif ! diff -bBdqa ${CONFDIR}/${I} ${CONFDIR}/${I}.orig > /dev/null; then\
            ${ECHO} "";\
            ${ECHO} "*****************************************************************************";\
            ${ECHO} "*****************************************************************************";\
            ${ECHO} "*****************************************************************************";\
            ${ECHO} "********** !!! old             ${CONFDIR}/${I}      **********";\
            ${ECHO} "********** !!! differ from new ${CONFDIR}/${I}.orig **********";\
            ${ECHO} "";\
            diff ${CONFDIR}/${I} ${CONFDIR}/${I}.orig || true;\
            ${ECHO} "";\
            ${ECHO} "*****************************************************************************";\
            ${ECHO} "*****************************************************************************";\
            ${ECHO} "*****************************************************************************";\
            ${ECHO} "";\
        fi
. endfor
.endif
.if defined(PROG)
. if defined(BINOVER)
	${MKDIR} -p ${BINOVER}
.  for I in ${PROG}
	${INSTALL_PROGRAM} ${I} ${BINOVER}
.  endfor
. else
	${MKDIR} -p ${BINDIR}
.  for I in ${PROG}
	${INSTALL_PROGRAM} ${I} ${BINDIR}
.  endfor
. endif
.endif
.if defined(SCRIPTS)
. if defined(BINOVER)
	${MKDIR} -p ${BINOVER}
.  for I in ${SCRIPTS}
.   if defined(SCRIPTFILTER)
	${SED} ${SCRIPTFILTER} ${I} > ${BINOVER}/${I}
	${CHOWN} ${CHOWNER} ${BINOVER}/${I}
	${CHMOD} ${BINMODE} ${BINOVER}/${I}
.   else
	${INSTALL_SCRIPT} ${I} ${BINOVER}
.   endif
.  endfor
. else
	${MKDIR} -p ${BINDIR}
.  for I in ${SCRIPTS}
.   if defined(SCRIPTFILTER)
	${SED} ${SCRIPTFILTER} ${I} > ${BINDIR}/${I}
	${CHOWN} ${CHOWNER} ${BINDIR}/${I}
	${CHMOD} ${BINMODE} ${BINDIR}/${I}
.   else
	${INSTALL_SCRIPT} ${I} ${BINDIR}
.   endif
.  endfor
. endif
.endif
.if defined(MANZ1)
	${MKDIR} -p ${MAN1DIR}
. for I in ${MANZ1}
	${INSTALL_MAN} ${I} ${MAN1DIR}
. endfor
.endif
.if defined(MANZ8)
	${MKDIR} -p ${MAN8DIR}
. for I in ${MANZ8}
	${INSTALL_MAN} ${I} ${MAN8DIR}
. endfor
.endif
.if defined(DATADIR)
. if defined(DATA)
	${MKDIR} -p ${DATADIR}
	${INSTALL_DATA} ${DATA} ${DATADIR}
. endif
. if defined(SAMPLE)
	${MKDIR} -p ${DATADIR}
.  for I in ${SAMPLE}
	${INSTALL_DATA} ./${I} ${DATADIR}/${I}.sample
	@if [ ! -e ${DATADIR}/${I} ]; then\
            ${INSTALL_DATA} ./${I} ${DATADIR}/;\
        fi
.  endfor
. endif
.endif

subdirinstall:
.for I in ${SUBDIR}
	@(cd ${I};\
          ${MAKE} ${MAKEFLAGS} PKG="${PKG}" VMAJOR="${VMAJOR}" VERS="${VERS}" DATE="${DATE}"\
                  BINMODE="${BINMODE}" MANMODE="${MANMODE}" DATAMODE="${DATAMODE}"\
                  INSTALL_PROGRAM="${INSTALL_PROGRAM}"\
                  INSTALL_SCRIPT="${INSTALL_SCRIPT}"\
                  INSTALL_DATA="${INSTALL_DATA}"\
                  INSTALL_MAN="${INSTALL_MAN}"\
                  OWNER="${OWNER}" CHOWNER="${CHOWNER}"\
                  PREFIX="${PREFIX}" BINDIR="${BINDIR}" MAN1DIR="${MAN1DIR}" MAN8DIR="${MAN8DIR}"\
                  LIBEDIR="${LIBEDIR}" CONFDIR="${CONFDIR}" ROOTDATA="${ROOTDATA}"\
                  install\
        )
.endfor

#######################################################################################################
tarball:
	${MKDIR} -p ${DISTNM}
	${CP} -p ${SRCS} ${MANS1} ${MANS8} ${MISC} ${SQLS} ${CONF} ${DISTNM}/
.for I in ${SUBDIR}
	@(cd ${I}; ${MAKE} PKG="${PKG}" ${MAKEFLAGS} DISTNM="../${DISTNM}/${I}" tarball)
.endfor
.if defined(VMINOR)
	${TAR} -czvf ${DISTNM}.tar.gz ${DISTNM}
	${RM} -rf ${DISTNM}
.endif

#######################################################################################################
release: tarball prerelease dorelease postrelease

dorelease:
.if defined(VMINOR)
	${CVS} tag r${VMAJOR}_${VMINOR}
.endif
.for I in ${REMOTE_SRCDIR}
	${SCP} ${DISTNM}.tar.gz ${I}
.endfor
.for I in ${LOCAL_SRCDIR}
	${CP} ${DISTNM}.tar.gz ${I}
.endfor
	${MD5} ${DISTNM}.tar.gz

#######################################################################################################
notify:
.if defined(REQUIRED)
	${BINDIR}/babololib-version ${REQUIRED}
.endif
	@${ECHO} "===> make in ${PKG}:${PWD}"

unnotify:
	@${ECHO} "===> end in ${PKG}:${PWD}"

preall:

postall:

preclean:

postclean:

preinstall:

postinstall:

prerelease:

postrelease:

clean: notify preclean doclean postclean

install: notify all preinstall doinstall subdirinstall postinstall unnotify
.if defined(VMINOR)
	${ECHO} "${VMAJOR}.${VMINOR}" > "${LIBINCLUDEDIR}/${PKG}.VERSION"
.endif

all: notify preall Makefile ${PROG} ${MGEN} ${SCRIPTS} ${MANZ1} ${MANZ8} subdir ${DATA} postall unnotify

